/*
 *  TOPPERS/JSP Educative Program
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2003-2004 by Platform Development Center
 *                              RICOH COMPANY,LTD. JAPAN
 *
 *  L쌠҂́CFree Software Foundation ɂČ\Ă 
 *  GNU General Public License  Version 2 ɋLqĂC
 *  (1)`(4)̏𖞂ꍇɌC{\tgEFAi{\tgEF
 *  Aς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFAėp\ȃoCiR[hiP[^uIu
 *      WFNgt@C⃉CuȂǁǰ`ŗpꍇɂ́Cp
 *      ɔhLgip҃}jAȂǁjɁCL̒쌠\C
 *      ̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAėps\ȃoCiR[ȟ`܂͋@ɑg
 *      ݍ񂾌`ŗpꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) pɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) p̌`ԂCʂɒ߂@ɂāCL쌠҂ɕ񍐂
 *        ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂́C
 *  {\tgEFAɊւāC̓Kp\܂߂āCȂۏ؂s
 *  ȂD܂C{\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ
 *  Ȃ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: timer3.h,v 1.1 2004/03/01 11:15:24 roi Exp $
 */

/* 
 *  j^[eXgpTvvÕwb_t@C
 */
#include <t_services.h>

#define TEX_LOOP	500000			/* O[`ł̃[v */


/*
 *  ^XNDx̐ݒ
 */
#define DEFAULT_MAIN_PRIORITY  8
#define TIMER_PRIORITY         9

/*
 *  ^[QbgɈˑ\̂萔̒`
 *  X^bNTCY
 */

#ifdef STACK_SIZE
#undef STACK_SIZE
#endif /* STACK_SIZE */
#define	STACK_SIZE	1024			/* ^XÑX^bNTCY */

/*
 *  ^C}[vZX̎Ԑݒ
 */
#define	T_TICK				250		/* s 250ms */
#define	T_1SEC				1000	/* ^C}[̂Pb */

/*
 *  EVT_FLGID̃rbg`
 */
#define	EVT_TIMER_START		0x01	/* ^C}[N */
#define	EVT_TIMER_COUNT		0x02	/* ^C}[JEgAbv */
#define	EVT_TIMER_STOP		0x04	/* ^C}[~ */

#define	EVT_TIME	(EVT_TIMER_START|EVT_TIMER_COUNT|EVT_TIMER_STOP)


/*
 * Onh̐ݒ
 */
#define	INT_IRG		64				/* CM[݃nhԍ */
#define EXC_IRG		64				/* CM[Onhԍ */
#define irregular_ext_handler_intmask  	IPM_LEVEL2

/*
 *  ֐̃vg^Cv錾
 */
#ifndef _MACRO_ONLY

extern void	entry_task(VP_INT exinf);
extern void timer_task(VP_INT exinf);

#endif /* _MACRO_ONLY */
