#include <winsock.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

int main()
{
	unsigned short port_no;
	WSADATA wsa_data;
	SOCKET listen_socket, transfer_socket;	
	SOCKADDR_IN server_addr, from_addr;
	int from_len, rcv_len;	
	char rcv_buf[1024];
	
	printf("Input port number =");
	scanf("%d", &port_no);

	if (WSAStartup(MAKEWORD(1, 1), &wsa_data)) {
		printf("WSAStartup Error\n");
		WSACleanup();
		return -1;
	}
	
	printf("Open socket portno = %d\n", port_no);
	listen_socket = socket(AF_INET, SOCK_STREAM, 0);
	if (listen_socket < 0) {
		printf( "Socket open Error\n" );
		WSACleanup();
		return -1;
	} else {
		printf("Socket open Success.\n");
	}

	memset(&server_addr, 0, sizeof(SOCKADDR_IN));
	server_addr.sin_family = AF_INET;
	server_addr.sin_port = htons(port_no);
	server_addr.sin_addr.s_addr = INADDR_ANY;

	if (bind(listen_socket, (struct sockaddr *)&server_addr, sizeof(server_addr)) == SOCKET_ERROR) {
		printf("bind Error");
		closesocket(listen_socket);
		WSACleanup();
		return -1;
	}  else {
		printf("bind Sucess\n");
	}

	if (listen(listen_socket, 0) == SOCKET_ERROR) {
		printf("listen Error\n");
		closesocket(listen_socket);
		WSACleanup();
		return -1; 
	} else {
		printf("listen Sucess\n");
	}

reaccept:
	printf("accept start\n");
	from_len = (int)sizeof(from_addr);
	transfer_socket = accept(listen_socket, (SOCKADDR *)&from_addr, &from_len);
	if (transfer_socket == INVALID_SOCKET) {
		printf("accept Error");
		closesocket(listen_socket);
		WSACleanup();
		return -1;
	} else {
		printf("%s has connected\n", inet_ntoa(from_addr.sin_addr));
		printf("accept Sucess\n");
	}

	while (1) {
		printf("Wait for Data...\n");
		rcv_len = recv(transfer_socket, rcv_buf, sizeof(rcv_buf) - 1, 0);
		
		if (rcv_len == SOCKET_ERROR) {
			printf("recv Error\n");
			break;
		}
		
		if (rcv_len == 0){
			printf("Client has cut connection\n");			
			break;
		}
		
		rcv_buf[rcv_len] = '\0';
		if (strcmp(rcv_buf, "_end_") == 0) {
			printf(" c_end receive!\n");
			break;
		}

		printf("Recived data  = %s\n",rcv_buf);

	}	
    send(transfer_socket, "_end_", (int)strlen("_end_"), 0);
    shutdown(transfer_socket, 1);	
	closesocket(transfer_socket);	
	printf("close socket\n");
	
	goto reaccept;
	WSACleanup();
	
	printf("End.....\n");	
	
	return 0;
}
