/* 
 *  DIPԒʒmNCAg
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include "device.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include "tcp_client.h"

/*
 *  O֐̒`
 */

extern const char *itron_strerror (ER ercd);

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  MEChEobt@TCY + MEChEobt@TCY
 *  傫Ȃ΁AfbhbN\B
 */

#define BUF_SIZE	2048 * 3


/*
 *  TCP Mobt@
 */

UB tcp_client_cep_sbuf[TCP_CLIENT_CEP_SBUF_SIZE];
UB tcp_client_cep_rbuf[TCP_CLIENT_CEP_RBUF_SIZE];

/*
 * Mobt@
 */
static UB 		sbuffer[BUF_SIZE];
static UB 		rbuffer[BUF_SIZE];

/*
 * Iʒm
 */ 
#define END_STAR "_end_"


/*
 * foCX[`
 */ 
void
device_init(VP_INT exinf)
{
	initial_switch();      /* XCb`̏ */
    initial_led();         /* LED̏ */
}

void
dip_monitor_task(VP_INT exinf)
{
	int	slen;
	
	syslog(LOG_NOTICE, "[DIP MONITOR] started.");

	while(TRUE) {
		if (get_switch(SW1) == ON) {
			sbuffer[0] = '1';
		}else{
			sbuffer[0] = '0';
		}		
		if (get_switch(SW2)  == ON) {
			sbuffer[1] = '1';
		}else{
			sbuffer[1] = '0';
		}
		if (get_switch(SW3) == ON) {
			sbuffer[2] = '1';			
		}else{
			sbuffer[2] = '0';
		}
		if (get_switch(SW4) == ON) {
			sbuffer[3] = '1';			
		}else{
			sbuffer[3] = '0';			
		}
		if ((slen = tcp_snd_dat(TCP_CLIENT_CEPID, &sbuffer, 4, TMO_FEVR)) < 0) {
			syslog(LOG_NOTICE, "[TCP CLIENT SND] error: %s",
				   itron_strerror(slen));		
		}
		dly_tsk(DIP_MONITOR_INTERVAL);
	}
}


void
tcp_client_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];
	T_IPV4EP		dst;
	ER	error = E_OK;
	char	c;
	ID tskid;
	int	slen;
	int rlen;
	
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP CLIENT] started.");

	/*
	 * ڑ̃|[g̐ݒE
	 */ 
	dst.ipaddr = DEST_ADDR;
	dst.portno = DEST_PORT;
	ip2str(addr, &dst.ipaddr);
	
	while (TRUE) {
		
		/*
		 * [_ւ̐ڑ
		 */ 
		do{
			syslog(LOG_NOTICE, "[TCP CLIENT] Push any key to connect");
			syscall(serial_rea_dat(TASK_PORTID, &c, 1));			
			syslog(LOG_NOTICE, "[TCP CLIENT CEP] connected to %s:%d", addr, dst.portno);
		
			if (error = tcp_con_cep(TCP_CLIENT_CEPID, (T_IPV4EP*)NADR, &dst, TMO_FEVR) != E_OK) {
				syslog(LOG_NOTICE, "[TCP CLIENT CEP] error: %s", itron_strerror(error));
				syslog(LOG_NOTICE, "[TCP CLIENT CEP] error code : %d", error);
			}
		}while(error != E_OK);
		
		syslog(LOG_NOTICE, "[TCP CLIENT CEP] connection establish.");

		/*
		 * f[^̑M
		 */ 
		syslog(LOG_NOTICE,"[TCP CLIENT] start to dip monitor task");
		syscall(act_tsk(DIP_MONITOR_TASK));
			
		syslog(LOG_NOTICE,"[TCP CLIENT] to disconnet, push Ctrl-C or Q ");
		do{
			syscall(serial_rea_dat(TASK_PORTID, &c, 1)); 
		}while(c != '\003' && c != 'Q');

		syslog(LOG_NOTICE,"[TCP CLIENT] terminate dip monitor task");
		syscall(ter_tsk(DIP_MONITOR_TASK));
		/* f[^̑M */
		if ((slen = tcp_snd_dat(TCP_CLIENT_CEPID, END_STAR, 5, TMO_FEVR)) < 0) {
			syslog(LOG_NOTICE, "[TCP CLIENT SND] can not send end data",
				   itron_strerror(slen));
		}

	  err_fin:		
		/* I̓ */
		if ((rlen = tcp_rcv_dat(TCP_CLIENT_CEPID, rbuffer, BUF_SIZE - 1, TMO_FEVR)) <= 0) {
			if (rlen != E_OK){
				syslog(LOG_NOTICE, "[TCP CLIENT RCV] error: %s", itron_strerror(rlen));
				*rbuffer = END_STAR;
			}
		}

		rbuffer[rlen] = '\0';
		if (strcmp(rbuffer, END_STAR) == 0){
			syslog(LOG_NOTICE, "[TCP CLIENT] finish");
		}else{
			goto err_fin;
		}

		/* |[g̃N[Y */
		if ((error = tcp_cls_cep(TCP_CLIENT_CEPID, TMO_FEVR)) != E_OK){
			syslog(LOG_NOTICE, "[TCP CLIENT CLS] error: %s", itron_strerror(error));
		}else{
			syslog(LOG_NOTICE, "[TCP CLIENT CLS] sucess");
		}
	}
}


