/* 
 *  IPv4ATCP NCAg
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include "tcp_client.h"

/*
 *  O֐̒`
 */

extern const char *itron_strerror (ER ercd);

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  MEChEobt@TCY + MEChEobt@TCY
 *  傫Ȃ΁AfbhbN\B
 */

#define BUF_SIZE	2048 * 3


/*
 *  TCP Mobt@
 */

UB tcp_client_cep_sbuf[TCP_CLIENT_CEP_SBUF_SIZE];
UB tcp_client_cep_rbuf[TCP_CLIENT_CEP_RBUF_SIZE];

/*
 * Mobt@
 */
static UB 		sbuffer[BUF_SIZE];
static UB 		rbuffer[BUF_SIZE];

/*
 * Iʒm
 */ 
#define END_STAR "_end_"

void
tcp_client_task(VP_INT exinf)
{
	static UB addr[sizeof("123.123.123.123")];
	T_IPV4EP		dst;
	ER	error = E_OK;
	char	c;
	ID tskid;
	int	slen;
	int rlen;
	
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP CLIENT :%d,%d] started.", tskid, (INT)exinf);

	/*
	 * ڑ̃|[g̐ݒ
	 */ 
	dst.ipaddr = DEST_ADDR;
	dst.portno = DEST_PORT;
	ip2str(addr, &dst.ipaddr);
	
	while (TRUE) {
		
		/*
		 * [_ւ̐ڑ
		 */ 
		do{
			syslog(LOG_NOTICE, "[TCP CLIENT] Push any key to connect");
			syscall(serial_rea_dat(TASK_PORTID, &c, 1));			
			syslog(LOG_NOTICE, "[TCP CLIENT CEP] connected to %s:%d", addr, dst.portno);
		
			if (error = tcp_con_cep(TCP_CLIENT_CEPID, (T_IPV4EP*)NADR, &dst, TMO_FEVR) != E_OK) {
				syslog(LOG_NOTICE, "[TCP CLIENT CEP] error: %s", itron_strerror(error));
			}
		}while(error != E_OK);
		
		syslog(LOG_NOTICE, "[TCP CLIENT CEP] connection establish.");

		/*
		 * f[^̑M
		 */ 
		while (TRUE) {
			/*
			 * G^[͂܂ŕǂݍ
			 */ 			 
			slen = 0;
			do{
				syscall(serial_rea_dat(TASK_PORTID, &c, 1));
				if (c == '\003' || c == 'Q'){
					/* Iʒm𑗂 */
					if ((slen = tcp_snd_dat(TCP_CLIENT_CEPID, END_STAR, 5, TMO_FEVR)) < 0) {
						syslog(LOG_NOTICE, "[TCP CLIENT SND] can not send end data",
							   itron_strerror(slen));
					}
					goto err_fin;
				}
				sbuffer[slen++] = c;
			}while(c != '\r');
			
			/* f[^̑M */
			sbuffer[--slen] = '\0';
			syslog(LOG_NOTICE, "[TCP CLIENT] send to : %s", sbuffer);
			if ((slen = tcp_snd_dat(TCP_CLIENT_CEPID, &sbuffer, slen, TMO_FEVR)) < 0) {
				syslog(LOG_NOTICE, "[TCP CLIENT SND] error: %s",
					   itron_strerror(slen));
				goto err_fin;				
			}
		}

    err_fin:
		/* I̓ */
		if ((rlen = tcp_rcv_dat(TCP_CLIENT_CEPID, rbuffer, BUF_SIZE - 1, TMO_FEVR)) <= 0) {
			if (rlen != E_OK){
				syslog(LOG_NOTICE, "[TCP CLIENT RCV] error: %s", itron_strerror(rlen));
				*rbuffer = END_STAR;
			}
		}

		rbuffer[rlen] = '\0';
		if (strcmp(rbuffer, END_STAR) == 0){
			syslog(LOG_NOTICE, "[TCP CLIENT ] finish");
		}else{
			goto err_fin;
		}

		/* |[g̃N[Y */
		if ((error = tcp_cls_cep(TCP_CLIENT_CEPID, TMO_FEVR)) != E_OK){
			syslog(LOG_NOTICE, "[TCP CLIENT CLS] error: %s", itron_strerror(error));
		}else{
			syslog(LOG_NOTICE, "[TCP CLIENT CLS] sucess");
		}
	}
}


