/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: tinet_app_config.h,v 1.0 2003/06/20 08:00:41 abe Exp abe $
 */

#ifndef _TINET_APP_CONFIG_H_
#define _TINET_APP_CONFIG_H_

/*
 *  C^[lbgvgRt@~[̃T|[g
 *
 *    Makefile Ŏw肵Ăǂ
 */

/*#define SUPPORT_INET4		   TCP/IP, IPv4			*/
/*#define SUPPORT_INET6		   TCP/IP, IPv6			*/
/*#define SUPPORT_TCP		   TCP				*/
/*#define SUPPORT_UDP		   UDP				*/

/*  f[^Nw̃lbg[NC^tF[XI	*/
/*  ꂩIłB				*/

/*#define SUPPORT_PPP		   Point to Point Protocol	*/
/*#define SUPPORT_LOOP		   Local Loop Back		*/
/*#define SUPPORT_ETHER		   Ethernet			*/

#define SUPPORT_MIB		   /* MIB (SNMP)		*/

/*
 *  TCP/IP Ɋւ`
 */

/* IPv4 Ɋւ` */

#ifdef SUPPORT_INET4

#ifdef SUPPORT_PPP

#if 1
#define IPV4_ADDR_LOCAL		0xc0a80115	/* 192.168.1.21 */
#else
#define IPV4_ADDR_LOCAL		0		/* Ɋ蓖ĂĂ炤ꍇ	*/
#endif

#if 1
#define IPV4_ADDR_REMOTE	0xc0a8011f	/* 192.168.1.31 */
#else
#define IPV4_ADDR_REMOTE	0		/* Ɋ蓖ĂĂ炤ꍇ	*/
#endif

#define NUM_STATIC_ROUTE_ENTRY		1
#define NUM_REDIRECT_ROUTE_ENTRY	0

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_ETHER

#ifdef DHCP_CFG

#define IPV4_ADDR_LOCAL		0x00000000
#define IPV4_ADDR_LOCAL_MASK	0x00000000

#else	/* of #ifdef DHCP_CFG */

#if 1	/* ROI MODIFIED */
#define IPV4_ADDR_LOCAL		0xc0a80b62	/* 192.168.11.98		*/
#define IPV4_ADDR_LOCAL_MASK	0xffffff00	/* 255.255.255.0	*/

#define IPV4_ADDR_DEFAULT_GW	0xc0a80b01	/* 192.168.11.1		*/
#else	/* ROI MODIFIED */
#define IPV4_ADDR_LOCAL		0xac198158	/* 172.31.1.88		*/
#define IPV4_ADDR_LOCAL_MASK	0xffffff00	/* 255.255.255.0	*/

#define IPV4_ADDR_DEFAULT_GW	0xac19818c	/* 172.25.129.140	*/
#endif	/* ROI MODIFIED */

#endif	/* of #ifdef DHCP_CFG */

#define NUM_STATIC_ROUTE_ENTRY		3
#define NUM_REDIRECT_ROUTE_ENTRY	0

#endif	/* of #ifdef SUPPORT_ETHER */

#ifdef SUPPORT_LOOP

#define NUM_STATIC_ROUTE_ENTRY		1
#define NUM_REDIRECT_ROUTE_ENTRY	0

#endif	/* of #ifdef SUPPORT_LOOP */

#endif	/* of #ifdef SUPPORT_INET4 */

/* IPv6 Ɋւ` */

#ifdef SUPPORT_INET6

#ifdef SUPPORT_PPP

#define NUM_STATIC_ROUTE_ENTRY		0
#define NUM_REDIRECT_ROUTE_ENTRY	0

#endif	/* of #ifdef SUPPORT_PPP */

#ifdef SUPPORT_LOOP

#define NUM_STATIC_ROUTE_ENTRY		0
#define NUM_REDIRECT_ROUTE_ENTRY	0

#endif	/* of #ifdef SUPPORT_LOOP */

#ifdef SUPPORT_ETHER

#define NUM_STATIC_ROUTE_ENTRY		0
#define NUM_REDIRECT_ROUTE_ENTRY	1

#endif	/* of #ifdef SUPPORT_ETHER */

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  f[^Nw (lbg[NC^tF[X) Ɋւ`
 */

/*
 *  PPP Ɋւ`
 */

#define HDLC_PORTID		1	/* HDLC(PPP)ɗpVA|[gԍ	*/

/*#define PPP_IDLE_TIMEOUT	(180*NET_TIMER_HZ)*/
					/* ؒf܂ł̃AChԁA		*/
					/* ؒfȂꍇ̓RgAEgB	*/

/*#define PPP_CFG_MODEM			 fڑ̏ꍇ̓RgOB	*/

#define MODEM_CFG_INIT		"ATE1&D0&S0\\V0\\Q1S0=1"
					/* f			*/
					/* NTT DoComo oCA_v^ 96F p	*/
					/*   E1: GR[obN			*/
					/*  &D0: ERM			*/
					/*  &S0: DRM펞 ON			*/
					/*  \V0: UgR[h TYPE 1		*/
					/*  \Q1: XON/XOFF t[		*/
					/* S0=1: MO = 1 	*/

#define MODEM_CFG_PHONE_NUMBER	"090-xxxx-9242"

					/* \̋Kl			*/
#define DEF_LCP_LOCAL_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_MAGIC|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)
/*#define DEF_LCP_LOCAL_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)*/

					/* ɋ\̋Kl		*/
#define DEF_LCP_REMOTE_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_MAGIC|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)
/*#define DEF_LCP_REMOTE_CFGS	(LCP_CFG_MRU|LCP_CFG_ACCM|LCP_CFG_ACCOMP|LCP_CFG_PCOMP|LCP_CFG_PAP)*/

/*
 *  F؂Ɋւ`
 */

#define AUTH_CFG_CLIENT		   	/* F؃NCAg[h̎̓RgOB	*/
#define AUTH_CFG_SERVER			/* F؃T[o[h̎̓RgOB		*/

#define AUTH_LOCAL_USER		"h8"		/* zXgւ̃OCF؃[U	*/
#define AUTH_LOCAL_PASSWD	"3048f"		/* zXgւ̃OCF؃pX[h	*/
#define AUTH_REMOTE_USER	"pen3"		/* ւ̃OCF؃[U		*/
#define AUTH_REMOTE_PASSWD	"600MHz"	/* ւ̃OCF؃pX[h		*/

/*
 *  ARP Ɋւ`
 */

/*#define ARP_CFG_CALLBACK_DUPLICATED*/	/* IP AhXdoR[obN֐	*/
					/* `ꍇ̓RgOB		*/

/*
 *  ICMPv4/v6 Ɋւ`
 */

#define ICMP_CFG_CALLBACK_ECHO_REPLY	/* ICMP ECHO MƂďoR[obN֐	*/
					/* `ꍇ̓RgOB			*/

#endif /* _TINET_APP_CONFIG_H_ */
